obj = {health = {},ammo = {},type ={},x = {},y = {},objimg = {},angle = {},status = {}}

addhook("startround","Reset")
function Reset()
	obj = {health = {},ammo = {},type ={},x = {},y = {},objimg ={},angle = {},status = {}}
end

function MakeStructure(hp,id,amunition,typ,tx,ty) -- Add Hitzone
	obj.health[id]=hp
	obj.ammo[id]=amunition
	obj.type[id]=typ
	obj.x[id]=tx
	obj.y[id]=ty
	obj.angle[id]=0
	obj.status[id] = 0
	if player(id,"team")==1 then
		if obj.objimg[id]== nil then
			obj.objimg[id]=image("gfx/sprites/RainingMammoths/CS2D/base t.png",0,0,1)
			obj.objimg[id*100+1]=image("gfx/flare1.bmp",0,0,1)
			imagecolor(obj.objimg[id*100+1],255,0,0)
			obj.objimg[id*100]=image("gfx/sprites/RainingMammoths/CS2D/turret.png",0,0,1)
		end
	elseif player(id,"team")==2 then
		if obj.objimg[id]== nil then
			obj.objimg[id]=image("gfx/sprites/RainingMammoths/CS2D/base ct.png",0,0,1)
			obj.objimg[id*100+1]=image("gfx/flare1.bmp",0,0,1)
			imagecolor(obj.objimg[id*100+1],0,0,255)
			obj.objimg[id*100]=image("gfx/sprites/RainingMammoths/CS2D/turret.png",0,0,1)
		end
	end
	imagescale(obj.objimg[id*100+1],1.75,1.75)
	imageblend(obj.objimg[id*100+1],1)
	imagepos(obj.objimg[id],obj.x[id]*32+16,obj.y[id]*32+16,0)
	imagepos(obj.objimg[id*100],obj.x[id]*32+16,obj.y[id]*32+16,obj.angle[id])
	imagepos(obj.objimg[id*100+1],obj.x[id]*32+16,obj.y[id]*32+16,obj.angle[id])
	imagehitzone(obj.objimg[id],2,-16,-16,32,32)
	tween_rotateconstantly(obj.objimg[id*100+1],1)
	--BoredRotation(id)
end

addhook("serveraction","ObjectControl")
function ObjectControl(id,b)
	if b == 1 then -- Building
		if obj.objimg[id] == nil then
			MakeStructure(500,id,60,"grenade",player(id,"tilex"),player(id,"tiley"))
		else
			parse('hudtxt2 '..id..' 1 "\169255000000You already have a turret placed..." 210 415 0')
			freetimer("parse","hudtxt2 "..id.." 1")
			timer(5000,"parse","hudtxt2 "..id.." 1")
			parse("hudtxtalphafade "..id.." 1 5000 0")
		end
	elseif b == 2 then -- Controlling inside of it.
		local distance = math.sqrt((obj.x[id]*32+16 - player(id,"x"))^2 + (obj.y[id]*32+16 - player(id,"y"))^2)
		if distance < 20 then
			if obj.status[id] == 0 then
				parse("setpos "..id.." "..obj.x[id]*32+16 .." "..obj.y[id]*32+16)
				parse("speedmod "..id.." -100")
				obj.status[id] = 1
			elseif obj.status[id] == 1 then
				parse("speedmod "..id.." 0")
				obj.status[id] = 0
			end
		end
	end
end

--[[function BoredRotation(id)
	obj.angle[id*100] = math.random(-180,180)
	if obj.angle[id*100] == 0 then
		BoredRotation(id)
	end
	tween_rotate(obj.objimg[id*100],2000,obj.angle[id*100])
	timer(2000,"BoredRotation",id)
end]]

function Angle(a1,a2,b1,b2) -- a1/b1 is y AND a2/b2 is x
	local ang = math.deg(math.atan2(a1 - b1, a2 - b2))
	return ang
end

addhook("use","SendOrder") -- Add Ammo.
function SendOrder(id)
	local distance = math.sqrt((obj.x[id]*32 - player(id,"x"))^2 + (obj.y[id]*32 - player(id,"y"))^2)
	if distance < 435 then
		reqcld(id,2)
		parse('hudtxt2 '..id..' 0 "\169255255255Ammo:'..obj.ammo[id]..' Health:'..obj.health[id]..'" 250 430 0')
	else
		parse('hudtxt2 '..id..' 1 "\169255000000You are too far away to control your turret..." 210 415 0')
		freetimer("parse","hudtxt2 "..id.." 1")
		timer(5000,"parse","hudtxt2 "..id.." 1")
		parse("hudtxtalphafade "..id.." 1 5000 0")
	end
end

addhook("clientdata","Shoot")
function Shoot(id,mode,d1,d2)
	if mode == 2 then
		local distance = math.sqrt((obj.x[id]*32 - d1)^2 + (obj.y[id]*32 - d2)^2)
		obj.angle[id] = Angle(obj.y[id]*32,obj.x[id]*32,d2,d1)-90
		if obj.status[id] == 0 then
			if obj.ammo[id]>0 then
				imagepos(obj.objimg[id*100],obj.x[id]*32+16,obj.y[id]*32+16,obj.angle[id])
				obj.ammo[id] = obj.ammo[id] - 1
				parse("spawnprojectile "..id.." 49 "..obj.x[id]*32+16 .." "..obj.y[id]*32+16 .." "..distance.." "..obj.angle[id]+math.random(-5,5))
				parse("sv_sound2 "..id.." weapons/glaunch.ogg")
			else
				parse('hudtxt2 '..id..' 1 "\169255000000Your turret does not have enough ammo..." 210 415 0')
				freetimer("parse","hudtxt2 "..id.." 1")
				timer(5000,"parse","hudtxt2 "..id.." 1")
				parse("hudtxtalphafade "..id.." 1 5000 0")
			end
		elseif obj.status[id] == 1 then
			if obj.ammo[id]>2 then
				imagepos(obj.objimg[id*100],obj.x[id]*32+16,obj.y[id]*32+16,obj.angle[id])
				obj.ammo[id] = obj.ammo[id] - 3
				parse("spawnprojectile "..id.." 48 "..obj.x[id]*32+16 .." "..obj.y[id]*32+16 .." "..math.random(240,600).." "..obj.angle[id]+math.random(-5,5))
				parse("sv_sound2 "..id.." weapons/rocket.ogg")
			else
				freetimer("parse","hudtxt2 "..id.." 1")
				timer(5000,"parse","hudtxt2 "..id.." 1")
				parse('hudtxt2 '..id..' 1 "\169255000000Your turret does not have enough ammo..." 210 415 0')
				parse("hudtxtalphafade "..id.." 1 5000 0")
			end
		end
	end
end

addhook("hitzone","Sustain")
function Sustain(imageid,sourceplayer,sourceobject,weapon,impx,impy,damage)
	for _, all in pairs(player(0,"table")) do
		if imageid == obj.objimg[all] then
			if player(sourceplayer,"team")~= player(all,"team") then
				obj.health[all] = obj.health[all] - damage
				if damage > obj.health[all] then
					parse("explosion "..obj.x[all]*32+16 .." "..obj.y[all]*32+16 .." 48 0 0")
					freeimage(obj.objimg[all])
					freeimage(obj.objimg[all*100])
					freeimage(obj.objimg[all*100+1])
					obj.objimg[all] = nil
					obj.objimg[all*100] = nil
					obj.objimg[all*100+1] = nil
					obj.status[all] = nil
					obj.health[all] = 0
				end
				parse('hudtxt2 '..all..' 0 "\169255255255Ammo:'..obj.ammo[all]..' Health:'..obj.health[all]..'" 250 430 0')
				break
			end
		end
	end
end

